void drawShape(float[][] dataMatrix, color c, color cb, float a) {
  for (int i = 0; i < 10; i++) {
    radY=i*TWO_PI/10;
    for (int j = 0; j < month-1; j++) {
      radM=(j+1)*(float)PI/13;
      noStroke();
      if(cline){
      stroke(c);}
      strokeWeight(1);
      float r = dataMatrix[i][j];
      //int r = 200;
      if (i<9) {
        beginShape();
        fill(c, a);
        vertex(r*sin(radY)*sin(radM), r*cos(radM), r*cos(radY)*sin(radM)); 
        vertex(dataMatrix[i][j+1]*sin(radY)*sin(radM+PI/13), dataMatrix[i][j+1]*cos(radM+PI/13), dataMatrix[i][j+1]*cos(radY)*sin(radM+PI/13));
        vertex(dataMatrix[i+1][j+1]*sin(radY+TWO_PI/10)*sin(radM+PI/13), dataMatrix[i+1][j+1]*cos(radM+PI/13), dataMatrix[i+1][j+1]*cos(radY+TWO_PI/10)*sin(radM+PI/13));
        endShape();
        beginShape();
        fill(c, a);
        vertex(r*sin(radY)*sin(radM), r*cos(radM), r*cos(radY)*sin(radM)); 
        vertex(dataMatrix[i+1][j]*sin(radY+TWO_PI/10)*sin(radM), dataMatrix[i+1][j]*cos(radM), dataMatrix[i+1][j]*cos(radY+TWO_PI/10)*sin(radM));
        vertex(dataMatrix[i+1][j+1]*sin(radY+TWO_PI/10)*sin(radM+PI/13), dataMatrix[i+1][j+1]*cos(radM+PI/13), dataMatrix[i+1][j+1]*cos(radY+TWO_PI/10)*sin(radM+PI/13));
        endShape();
      }
      if (i == 9) {
        beginShape();
        fill(c, a);
        vertex(r*sin(radY)*sin(radM), r*cos(radM), r*cos(radY)*sin(radM)); 
        vertex(dataMatrix[i][j+1]*sin(radY)*sin(radM+PI/13), dataMatrix[i][j+1]*cos(radM+PI/13), dataMatrix[i][j+1]*cos(radY)*sin(radM+PI/13));
        vertex(dataMatrix[0][j+1]*sin(radY+TWO_PI/10)*sin(radM+PI/13), dataMatrix[0][j+1]*cos(radM+PI/13), dataMatrix[0][j+1]*cos(radY+TWO_PI/10)*sin(radM+PI/13));
        endShape();

        beginShape();
        fill(c, a);
        vertex(r*sin(radY)*sin(radM), r*cos(radM), r*cos(radY)*sin(radM)); 
        vertex(dataMatrix[0][j]*sin(radY+TWO_PI/10)*sin(radM), dataMatrix[0][j]*cos(radM), dataMatrix[0][j]*cos(radY+TWO_PI/10)*sin(radM));
        vertex(dataMatrix[0][j+1]*sin(radY+TWO_PI/10)*sin(radM+PI/13), dataMatrix[0][j+1]*cos(radM+PI/13), dataMatrix[0][j+1]*cos(radY+TWO_PI/10)*sin(radM+PI/13));
        endShape();
      }
    }
  }





//-----------------------------
//surfaces on the top & bottom
//-----------------------------

//top--------------------------
  beginShape();
  fill(c, a);
  int k = 1;
  vertex(dataMatrix[k][0]*sin(TWO_PI/10*k)*sin(PI/13), dataMatrix[k][0]*cos(PI/13), dataMatrix[k][0]*cos(TWO_PI/10*k)*sin(PI/13));
  k = 2;
  vertex(dataMatrix[k][0]*sin(TWO_PI/10*k)*sin(PI/13), dataMatrix[k][0]*cos(PI/13), dataMatrix[k][0]*cos(TWO_PI/10*k)*sin(PI/13));
  k = 3;
  vertex(dataMatrix[k][0]*sin(TWO_PI/10*k)*sin(PI/13), dataMatrix[k][0]*cos(PI/13), dataMatrix[k][0]*cos(TWO_PI/10*k)*sin(PI/13));
  endShape();

  beginShape();
  fill(c, a);
  k = 3;
  vertex(dataMatrix[k][0]*sin(TWO_PI/10*k)*sin(PI/13), dataMatrix[k][0]*cos(PI/13), dataMatrix[k][0]*cos(TWO_PI/10*k)*sin(PI/13));
  k = 4;
  vertex(dataMatrix[k][0]*sin(TWO_PI/10*k)*sin(PI/13), dataMatrix[k][0]*cos(PI/13), dataMatrix[k][0]*cos(TWO_PI/10*k)*sin(PI/13));
  k = 1;
  vertex(dataMatrix[k][0]*sin(TWO_PI/10*k)*sin(PI/13), dataMatrix[k][0]*cos(PI/13), dataMatrix[k][0]*cos(TWO_PI/10*k)*sin(PI/13));
  endShape();

  beginShape();
  fill(c, a);
  k = 0;
  vertex(dataMatrix[k][0]*sin(TWO_PI/10*k)*sin(PI/13), dataMatrix[k][0]*cos(PI/13), dataMatrix[k][0]*cos(TWO_PI/10*k)*sin(PI/13));
  k = 1;
  vertex(dataMatrix[k][0]*sin(TWO_PI/10*k)*sin(PI/13), dataMatrix[k][0]*cos(PI/13), dataMatrix[k][0]*cos(TWO_PI/10*k)*sin(PI/13));
  k = 4;
  vertex(dataMatrix[k][0]*sin(TWO_PI/10*k)*sin(PI/13), dataMatrix[k][0]*cos(PI/13), dataMatrix[k][0]*cos(TWO_PI/10*k)*sin(PI/13));
  endShape();

  beginShape();
  fill(c, a);
  k = 0;
  vertex(dataMatrix[k][0]*sin(TWO_PI/10*k)*sin(PI/13), dataMatrix[k][0]*cos(PI/13), dataMatrix[k][0]*cos(TWO_PI/10*k)*sin(PI/13));
  k = 4;
  vertex(dataMatrix[k][0]*sin(TWO_PI/10*k)*sin(PI/13), dataMatrix[k][0]*cos(PI/13), dataMatrix[k][0]*cos(TWO_PI/10*k)*sin(PI/13));
  k = 5;
  vertex(dataMatrix[k][0]*sin(TWO_PI/10*k)*sin(PI/13), dataMatrix[k][0]*cos(PI/13), dataMatrix[k][0]*cos(TWO_PI/10*k)*sin(PI/13));
  endShape();

  beginShape();
  fill(c, a);
  k = 9;
  vertex(dataMatrix[k][0]*sin(TWO_PI/10*k)*sin(PI/13), dataMatrix[k][0]*cos(PI/13), dataMatrix[k][0]*cos(TWO_PI/10*k)*sin(PI/13));
  k = 0;
  vertex(dataMatrix[k][0]*sin(TWO_PI/10*k)*sin(PI/13), dataMatrix[k][0]*cos(PI/13), dataMatrix[k][0]*cos(TWO_PI/10*k)*sin(PI/13));
  k = 5;
  vertex(dataMatrix[k][0]*sin(TWO_PI/10*k)*sin(PI/13), dataMatrix[k][0]*cos(PI/13), dataMatrix[k][0]*cos(TWO_PI/10*k)*sin(PI/13));
  endShape();

  beginShape();
  fill(c, a);
  k = 9;
  vertex(dataMatrix[k][0]*sin(TWO_PI/10*k)*sin(PI/13), dataMatrix[k][0]*cos(PI/13), dataMatrix[k][0]*cos(TWO_PI/10*k)*sin(PI/13));
  k = 5;
  vertex(dataMatrix[k][0]*sin(TWO_PI/10*k)*sin(PI/13), dataMatrix[k][0]*cos(PI/13), dataMatrix[k][0]*cos(TWO_PI/10*k)*sin(PI/13));
  k = 6;
  vertex(dataMatrix[k][0]*sin(TWO_PI/10*k)*sin(PI/13), dataMatrix[k][0]*cos(PI/13), dataMatrix[k][0]*cos(TWO_PI/10*k)*sin(PI/13));
  endShape();

  beginShape();
  fill(c, a);
  k = 9;
  vertex(dataMatrix[k][0]*sin(TWO_PI/10*k)*sin(PI/13), dataMatrix[k][0]*cos(PI/13), dataMatrix[k][0]*cos(TWO_PI/10*k)*sin(PI/13));
  k = 8;
  vertex(dataMatrix[k][0]*sin(TWO_PI/10*k)*sin(PI/13), dataMatrix[k][0]*cos(PI/13), dataMatrix[k][0]*cos(TWO_PI/10*k)*sin(PI/13));
  k = 6;
  vertex(dataMatrix[k][0]*sin(TWO_PI/10*k)*sin(PI/13), dataMatrix[k][0]*cos(PI/13), dataMatrix[k][0]*cos(TWO_PI/10*k)*sin(PI/13));
  endShape();

  beginShape();
  fill(c, a);
  k = 6;
  vertex(dataMatrix[k][0]*sin(TWO_PI/10*k)*sin(PI/13), dataMatrix[k][0]*cos(PI/13), dataMatrix[k][0]*cos(TWO_PI/10*k)*sin(PI/13));
  k = 7;
  vertex(dataMatrix[k][0]*sin(TWO_PI/10*k)*sin(PI/13), dataMatrix[k][0]*cos(PI/13), dataMatrix[k][0]*cos(TWO_PI/10*k)*sin(PI/13));
  k = 8;
  vertex(dataMatrix[k][0]*sin(TWO_PI/10*k)*sin(PI/13), dataMatrix[k][0]*cos(PI/13), dataMatrix[k][0]*cos(TWO_PI/10*k)*sin(PI/13));
  endShape();







//bottom---------------------------------------
  beginShape();
  fill(c, a);
  k = 1;
  vertex(dataMatrix[k][11]*sin(TWO_PI/10*k)*sin(12*PI/13), dataMatrix[k][11]*cos(12*PI/13), dataMatrix[k][11]*cos(TWO_PI/10*k)*sin(12*PI/13));
  k = 2;
  vertex(dataMatrix[k][11]*sin(TWO_PI/10*k)*sin(12*PI/13), dataMatrix[k][11]*cos(12*PI/13), dataMatrix[k][11]*cos(TWO_PI/10*k)*sin(12*PI/13));
  k = 3;
  vertex(dataMatrix[k][11]*sin(TWO_PI/10*k)*sin(12*PI/13), dataMatrix[k][11]*cos(12*PI/13), dataMatrix[k][11]*cos(TWO_PI/10*k)*sin(12*PI/13));
  endShape();

  beginShape();
  fill(c, a);
  k = 3;
  vertex(dataMatrix[k][11]*sin(TWO_PI/10*k)*sin(12*PI/13), dataMatrix[k][11]*cos(12*PI/13), dataMatrix[k][11]*cos(TWO_PI/10*k)*sin(12*PI/13));
  k = 4;
  vertex(dataMatrix[k][11]*sin(TWO_PI/10*k)*sin(12*PI/13), dataMatrix[k][11]*cos(12*PI/13), dataMatrix[k][11]*cos(TWO_PI/10*k)*sin(12*PI/13));
  k = 1;
  vertex(dataMatrix[k][11]*sin(TWO_PI/10*k)*sin(12*PI/13), dataMatrix[k][11]*cos(12*PI/13), dataMatrix[k][11]*cos(TWO_PI/10*k)*sin(12*PI/13));
  endShape();

  beginShape();
  fill(c, a);
  k = 0;
  vertex(dataMatrix[k][11]*sin(TWO_PI/10*k)*sin(12*PI/13), dataMatrix[k][11]*cos(12*PI/13), dataMatrix[k][11]*cos(TWO_PI/10*k)*sin(12*PI/13));
  k = 1;
  vertex(dataMatrix[k][11]*sin(TWO_PI/10*k)*sin(12*PI/13), dataMatrix[k][11]*cos(12*PI/13), dataMatrix[k][11]*cos(TWO_PI/10*k)*sin(12*PI/13));
  k = 4;
  vertex(dataMatrix[k][11]*sin(TWO_PI/10*k)*sin(12*PI/13), dataMatrix[k][11]*cos(12*PI/13), dataMatrix[k][11]*cos(TWO_PI/10*k)*sin(12*PI/13));
  endShape();

  beginShape();
  fill(c, a);
  k = 0;
  vertex(dataMatrix[k][11]*sin(TWO_PI/10*k)*sin(12*PI/13), dataMatrix[k][11]*cos(12*PI/13), dataMatrix[k][11]*cos(TWO_PI/10*k)*sin(12*PI/13));
  k = 4;
  vertex(dataMatrix[k][11]*sin(TWO_PI/10*k)*sin(12*PI/13), dataMatrix[k][11]*cos(12*PI/13), dataMatrix[k][11]*cos(TWO_PI/10*k)*sin(12*PI/13));
  k = 5;
  vertex(dataMatrix[k][11]*sin(TWO_PI/10*k)*sin(12*PI/13), dataMatrix[k][11]*cos(12*PI/13), dataMatrix[k][11]*cos(TWO_PI/10*k)*sin(12*PI/13));
  endShape();

  beginShape();
  fill(c, a);
  k = 9;
  vertex(dataMatrix[k][11]*sin(TWO_PI/10*k)*sin(12*PI/13), dataMatrix[k][11]*cos(12*PI/13), dataMatrix[k][11]*cos(TWO_PI/10*k)*sin(12*PI/13));
  k = 0;
  vertex(dataMatrix[k][11]*sin(TWO_PI/10*k)*sin(12*PI/13), dataMatrix[k][11]*cos(12*PI/13), dataMatrix[k][11]*cos(TWO_PI/10*k)*sin(12*PI/13));
  k = 5;
  vertex(dataMatrix[k][11]*sin(TWO_PI/10*k)*sin(12*PI/13), dataMatrix[k][11]*cos(12*PI/13), dataMatrix[k][11]*cos(TWO_PI/10*k)*sin(12*PI/13));
  endShape();

  beginShape();
  fill(c, a);
  k = 9;
  vertex(dataMatrix[k][11]*sin(TWO_PI/10*k)*sin(12*PI/13), dataMatrix[k][11]*cos(12*PI/13), dataMatrix[k][11]*cos(TWO_PI/10*k)*sin(12*PI/13));
  k = 5;
  vertex(dataMatrix[k][11]*sin(TWO_PI/10*k)*sin(12*PI/13), dataMatrix[k][11]*cos(12*PI/13), dataMatrix[k][11]*cos(TWO_PI/10*k)*sin(12*PI/13));
  k = 6;
  vertex(dataMatrix[k][11]*sin(TWO_PI/10*k)*sin(12*PI/13), dataMatrix[k][11]*cos(12*PI/13), dataMatrix[k][11]*cos(TWO_PI/10*k)*sin(12*PI/13));
  endShape();

  beginShape();
  fill(c, a);
  k = 9;
  vertex(dataMatrix[k][11]*sin(TWO_PI/10*k)*sin(12*PI/13), dataMatrix[k][11]*cos(12*PI/13), dataMatrix[k][11]*cos(TWO_PI/10*k)*sin(12*PI/13));
  k = 8;
  vertex(dataMatrix[k][11]*sin(TWO_PI/10*k)*sin(12*PI/13), dataMatrix[k][11]*cos(12*PI/13), dataMatrix[k][11]*cos(TWO_PI/10*k)*sin(12*PI/13));
  k = 6;
  vertex(dataMatrix[k][11]*sin(TWO_PI/10*k)*sin(12*PI/13), dataMatrix[k][11]*cos(12*PI/13), dataMatrix[k][11]*cos(TWO_PI/10*k)*sin(12*PI/13));
  endShape();

  beginShape();
  fill(c, a);
  k = 6;
  vertex(dataMatrix[k][11]*sin(TWO_PI/10*k)*sin(12*PI/13), dataMatrix[k][11]*cos(12*PI/13), dataMatrix[k][11]*cos(TWO_PI/10*k)*sin(12*PI/13));
  k = 7;
  vertex(dataMatrix[k][11]*sin(TWO_PI/10*k)*sin(12*PI/13), dataMatrix[k][11]*cos(12*PI/13), dataMatrix[k][11]*cos(TWO_PI/10*k)*sin(12*PI/13));
  k = 8;
  vertex(dataMatrix[k][11]*sin(TWO_PI/10*k)*sin(12*PI/13), dataMatrix[k][11]*cos(12*PI/13), dataMatrix[k][11]*cos(TWO_PI/10*k)*sin(12*PI/13));
  endShape();
}