//-----------------------------
//draw horizontal lines
//-----------------------------
void drawHLine(float[][] dataMatrix,color c) { 
    for (int i = 0; i < 10; i++) {
    radY=i*TWO_PI/10;
    for (int j = 0; j < month-1; j++) {
      radM=(j+1)*(float)PI/13;
      stroke(c);
      strokeWeight(1);
      float r = dataMatrix[i][j];
      //int r = 200;
      line(r*sin(radY)*sin(radM), r*cos(radM), r*cos(radY)*sin(radM), 
        dataMatrix[i][j+1]*sin(radY)*sin(radM+PI/13), dataMatrix[i][j+1]*cos(radM+PI/13), dataMatrix[i][j+1]*cos(radY)*sin(radM+PI/13));
    }
  }
}


//-----------------------------
//draw vertical lines
//-----------------------------
void drawVLine(float[][] dataMatrix,color c) {
  for (int j = 0; j < month; j++) {
    radM=(j+1)*(float)PI/13;
    for (int i = 0; i < 10; i++) {
      radY=i*TWO_PI/10;
      stroke(c);
      strokeWeight(1);
      float r = dataMatrix[i][j];
      if (i<9) {
        line(r*sin(radY)*sin(radM), r*cos(radM), r*cos(radY)*sin(radM), 
          dataMatrix[i+1][j]*sin(radY+TWO_PI/10)*sin(radM), dataMatrix[i+1][j]*cos(radM), dataMatrix[i+1][j]*cos(radY+TWO_PI/10)*sin(radM));
      }
      if (i==9) {
        line(r*sin(radY)*sin(radM), r*cos(radM), r*cos(radY)*sin(radM), 
          dataMatrix[0][j]*sin(radY+TWO_PI/10)*sin(radM), dataMatrix[0][j]*cos(radM), dataMatrix[0][j]*cos(radY+TWO_PI/10)*sin(radM));
      }
    }
  }
}