void gui() {
  hint(DISABLE_DEPTH_TEST);
  cam.beginHUD();
  cp5.draw();
  //-----------------------------
  //title
  //-----------------------------
  fill(230);
  textAlign(LEFT);
  textFont(f);
  textSize(50);
  text("STAR WARS NEBULA", horMargin, verMargin);
  textSize(16);
  //text("Checkout Times and Duration Times of the", 
  //  horMargin+320, verMargin-40);
  //text("Former 6 in the Serie in Seattle Public Library ", 
  //  horMargin+320, verMargin-20);
  //text("Checkout Times and Duration Times of the", 
  //  horMargin, verMargin+18-20);
  //text("Former 6 in the Serie in Seattle Public Library ", 
  //  horMargin, verMargin+36-20);
  text("Using Data of Checkout Times and Duration Times of the Former 6 in This Movie Series in Seattle Public Library", 
    horMargin, verMargin+18);



  //-----------------------------
  //button for highlighting
  //-----------------------------

  //YEAR-------------------------

  textAlign(LEFT, CENTER);
  fill(200);
  textSize(20);
  text("Year", 
    horMargin, verMargin+72-22);
  rectMode(CORNER);
  for (int i = 0; i < year; i++) {
    if (horMargin<mouseX&&mouseX<horMargin+42) {
      if (mouseY>verMargin+14*i-6+90-20&&mouseY<verMargin+14*i+6+90-20) {
        noStroke();
        fill(200, 50);
        rect(horMargin, verMargin+14*i-6+90-21, 42, 12);
      }
    }
    if (highlightingYear[i]) {
      noStroke();
      fill(255, 100);
      rect(horMargin, verMargin+14*i-6+90-21, 42, 12);
    }
  }
  int startYear=2006;
  for (int i = 0; i < year; i++) {
    textAlign(LEFT, CENTER);
    textSize(12);
    fill(200);
    text(startYear+i, horMargin+1, verMargin + 14*i + 90-22);
  }


  //Month-------------------------------------------------------
  textSize(20);
  text("Month", 
    horMargin+80, verMargin+72-22);
  for (int i = 0; i < month; i++) {
    if (horMargin+80<mouseX&&mouseX<horMargin+151) {
      if (mouseY>verMargin+14*i-6+90-20&&mouseY<verMargin+14*i+6+90-20) {
        noStroke();
        fill(200, 50);
        rect(horMargin+80, verMargin+14*i-6+90-20, 60, 12);
      }
    }
    if (highlightingMonth[i]) {
      noStroke();
      fill(255, 100);
      rect(horMargin+80, verMargin+14*i-6+90-20, 60, 12);
    }
  }
  for (int i = 0; i < month; i++) {
    textAlign(LEFT, CENTER);
    textSize(12);
    fill(200);
    text(monthName[i], horMargin+1+80, verMargin + 14*i + 90-22);
  }


  //Reset------------------------------------------------------------
  textSize(20);
  fill(200);
  text("Reset", 
    horMargin, verMargin+250-4);
  textSize(12);
  textAlign(LEFT, CENTER);
  text("Years", 
    horMargin+1, verMargin+250+14);
  text("Months", 
    horMargin+1, verMargin+250+28);
  text("All", 
    horMargin+1, verMargin+250+42);
  for (int i = 0; i < 3; i++) {
    if (horMargin<mouseX&&mouseX<horMargin+52) {
      if (mouseY>verMargin+14*(i+1)+250&&mouseY<verMargin+14*(i+2)+250) {
        noStroke();
        fill(200, 50);
        rect(horMargin, verMargin+14*(i+1)+250-5, 52, 12);
      }
    }
  }




  //-----------------------------
  //name
  //-----------------------------
  fill(200);
  textAlign(LEFT, CENTER);
  textSize(14);
  text("Junxiang Yao", 
    width - horMargin - 200, verMargin+330);
  text("MAT259 PROJ 2", 
    width - horMargin - 200, verMargin+346);
  text("3D Interaction & Change Over Time", 
    width - horMargin - 200, verMargin+360);



  //-----------------------------
  //grid system
  //----------------------------- 
  if (grid) {
    stroke(#6d6cca);
    strokeWeight(1);
    line(0, verMargin, width, verMargin);
    line(0, verMargin+8+16, width, verMargin+8+16);
    line(0, verMargin+8+16+20, width, verMargin+8+16+20);
    line(0, verMargin+8+16+40, width, verMargin+8+16+40);
    line(0, verMargin+8+16+206, width, verMargin+8+16+206);
    line(0, verMargin+8+16+216, width, verMargin+8+16+216);
    line(0, verMargin+8+16+304, width, verMargin+8+16+304);
    line(0, verMargin+412, width, verMargin+412);
    line(0, height-verMargin, width, height-verMargin);

    line(horMargin, 0, horMargin, height);
    line(horMargin + 80, 0, horMargin + 80, height);
    line(horMargin + 160, 0, horMargin + 160, height);
    line(width - horMargin - 200, 0, width - horMargin - 200, height); 
    line(width-horMargin, 0, width-horMargin, height);
  }


  //-----------------------------
  //keyboard  control discription
  //-----------------------------
  fill(200);
  textSize(20);
  text("Keyboard Control", 
    horMargin, verMargin+416);


  textSize(12);
  textAlign(LEFT, CENTER);

  text("Press 1 / 2 / 3 / 4 / 5 / 6 to check movie individually", 
    horMargin, verMargin+416+20);
  text("Press 7 / 8 to check the original / prequel trilogy", 
    horMargin, verMargin+14+416+20);
  text("Press 9 / 0 to check all in one / different cordinate systems", 
    horMargin, verMargin+28+416+20);
  text("Press D to show / hide dots of duration times", 
    horMargin, verMargin+42+416+20);  
  text("Press S to show / hide the solids", 
    horMargin, verMargin+56+416+20);
  text("Press N to show / hide the cromatic frames", 
    horMargin, verMargin+70+416+20);
  text("Press F to show / hide grey frames", 
    horMargin, verMargin+84+416+20);
  text("Press T to show / hide the verbal information", 
    horMargin, verMargin+98+416+20);
  text("Press L to show / hide the cordinate axis and lables", 
    horMargin, verMargin+112+416+20);


  //-----------------------------
  //scaling legend
  //-----------------------------
  fill(200);
  textSize(12);
  text("The radius of the circular cordinate", 
    width - horMargin - 200, verMargin+416);
  text("axis is 200 checkout times.", 
    width - horMargin - 200, verMargin+430);
  text("Duration time scaling:", 
    width - horMargin - 200, verMargin+458);
  textSize(10);
  for (int i = 0; i < 6; i++) {
    noStroke();
    textAlign(CENTER);
    fill(200, 150);
    ellipse( width - horMargin - 200 + 24*i + 12*i + 6, verMargin+490, 4 *(i+1), 4*(i+1));
    fill(200);
    text(40*(i+1), width - horMargin - 200 + 24*i + 12*i + 6, verMargin+490+24);
  }


  //-----------------------------
  //color legend
  //-----------------------------
  if (showLegend) {
    fill(200);
    textSize(12);
    textAlign(LEFT, CENTER);
    text("Star Wars I (1999)", 
      horMargin + 6 + 160, verMargin+330+1);
    text("Star Wars II (2002)", 
      horMargin + 6 + 160, verMargin+344+1);
    text("Star Wars III (2005)", 
      horMargin + 6 + 160, verMargin+358+1);
    text("Star Wars IV (1977)", 
      horMargin + 6, verMargin+330+1);
    text("Star Wars V (1980)", 
      horMargin + 6, verMargin+344+1);
    text("Star Wars VI (1983)", 
      horMargin + 6, verMargin+358+1);
    rectMode(CENTER);
    fill(color(#ff3535)); 
    noStroke(); 
    rect(horMargin + 1 + 160, verMargin+330+2, 2, 10);
    fill(color(#fe9a2e)); 
    noStroke(); 
    rect(horMargin + 1 + 160, verMargin+344+2, 2, 10);
    fill(color(#edc628)); 
    noStroke(); 
    rect(horMargin + 1 + 160, verMargin+358+2, 2, 10);
    fill(color(#70b70a)); 
    noStroke(); 
    rect(horMargin + 1, verMargin+330+2, 2, 10);
    fill(color(#4c97dc)); 
    noStroke(); 
    rect(horMargin + 1, verMargin+344+2, 2, 10);
    fill(color(#6d6cca)); 
    noStroke(); 
    rect(horMargin + 1, verMargin+358+2, 2, 10);
  }



  cam.endHUD();
  hint(ENABLE_DEPTH_TEST);
}